﻿using TAlex.PowerCalc.Services;
namespace TAlex.PowerCalc.Properties {
    
    
    // This class allows you to handle specific events on the settings class:
    //  The SettingChanging event is raised before a setting's value is changed.
    //  The PropertyChanged event is raised after a setting's value is changed.
    //  The SettingsLoaded event is raised after the setting values are loaded.
    //  The SettingsSaving event is raised before the setting values are saved.
    internal sealed partial class Settings : IAppSettings {

        public Settings()
        {
            if (CallUpgrade)
            {
                Upgrade();
                CallUpgrade = false;
            }

            TAlex.WPF.Theming.ThemeLocator.Manager.ThemeChanged += Manager_ThemeChanged;
        }

        private void Manager_ThemeChanged(object sender, WPF.Theming.ThemeEventArgs args)
        {
            ColorScheme = args.NewTheme;
        }
    }
}
